unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    EditA1: TEdit;
    EditA2: TEdit;
    StaticText1: TStaticText;
    StaticText4: TStaticText;
    EditA3: TEdit;
    EditB1: TEdit;
    EditB2: TEdit;
    EditB3: TEdit;
    EditC1: TEdit;
    EditC2: TEdit;
    EditC3: TEdit;
    EditD1: TEdit;
    EditD2: TEdit;
    EditD3: TEdit;
    StaticText2: TStaticText;
    EditAc1: TEdit;
    EditAc2: TEdit;
    EditAc3: TEdit;
    EditBc1: TEdit;
    EditBc2: TEdit;
    EditBc3: TEdit;
    EditCc1: TEdit;
    EditCc2: TEdit;
    EditCc3: TEdit;
    EditDc1: TEdit;
    EditDc2: TEdit;
    EditDc3: TEdit;
    StaticText3: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    EditAlfa: TEdit;
    EditBeta: TEdit;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText18: TStaticText;
    EditP1: TEdit;
    EditP2: TEdit;
    EditP3: TEdit;
    StaticText19: TStaticText;
    EditQ1: TEdit;
    EditQ2: TEdit;
    EditQ3: TEdit;
    StaticText20: TStaticText;
    StaticText21: TStaticText;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    StaticText17: TStaticText;
    StaticText22: TStaticText;
    StaticText23: TStaticText;
    Procedure Setting;
    procedure Movies(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Control_Panel: TControl_Panel;

implementation

uses Graph3D_2005;

var Box1,Box2      :TBox;
    Rychlost       :Double;
    Alfa,Beta      :Double;
    PointP,PointQ  :T3DPoint;
    Continue       :Boolean;

{$R *.DFM}


Procedure SettingBox(var Box:TBox);
 var Code :Integer;
  begin
   With Control_Panel do
   begin
    Val(EditA1.Text,Box.A[1],Code);
    Val(EditA2.Text,Box.A[2],Code);
    Val(EditA3.Text,Box.A[3],Code);
    Val(EditB1.Text,Box.B[1],Code);
    Val(EditB2.Text,Box.B[2],Code);
    Val(EditB3.Text,Box.B[3],Code);
    Val(EditC1.Text,Box.C[1],Code);
    Val(EditC2.Text,Box.C[2],Code);
    Val(EditC3.Text,Box.C[3],Code);
    Val(EditD1.Text,Box.D[1],Code);
    Val(EditD2.Text,Box.D[2],Code);
    Val(EditD3.Text,Box.D[3],Code);
    Val(EditAc1.Text,Box.Ac[1],Code);
    Val(EditAc2.Text,Box.Ac[2],Code);
    Val(EditAc3.Text,Box.Ac[3],Code);
    Val(EditBc1.Text,Box.Bc[1],Code);
    Val(EditBc2.Text,Box.Bc[2],Code);
    Val(EditBc3.Text,Box.Bc[3],Code);
    Val(EditCc1.Text,Box.Cc[1],Code);
    Val(EditCc2.Text,Box.Cc[2],Code);
    Val(EditCc3.Text,Box.Cc[3],Code);
    Val(EditDc1.Text,Box.Dc[1],Code);
    Val(EditDc2.Text,Box.Dc[2],Code);
    Val(EditDc3.Text,Box.Dc[3],Code);
    Val(EditP1.Text,PointP[1],Code);
    Val(EditP2.Text,PointP[2],Code);
    Val(EditP3.Text,PointP[3],Code);
    Val(EditQ1.Text,PointQ[1],Code);
    Val(EditQ2.Text,PointQ[2],Code);
    Val(EditQ3.Text,PointQ[3],Code);
    end;
    With Box do
    begin
    A[4]:=1;B[4]:=1;C[4]:=1;D[4]:=1;
    Ac[4]:=1;Bc[4]:=1;Cc[4]:=1;Dc[4]:=1;
    end;
   end;

Procedure TransOfBox(Box1:TBox;Mat:TMatrix;var Box2:TBox);
   begin
   With Draw3d do
    begin
      TransOfPoint(Box1.A,Mat,Box2.A);
      TransOfPoint(Box1.B,Mat,Box2.B);
      TransOfPoint(Box1.C,Mat,Box2.C);
      TransOfPoint(Box1.D,Mat,Box2.D);
      TransOfPoint(Box1.Ac,Mat,Box2.Ac);
      TransOfPoint(Box1.Bc,Mat,Box2.Bc);
      TransOfPoint(Box1.Cc,Mat,Box2.Cc);
      TransOfPoint(Box1.Dc,Mat,Box2.Dc);
    end;
   end;

Procedure TControl_Panel.Setting;
var Code:Integer;
  begin
   With Draw3D do
   begin
    Val(EditX1.Text,X1,Code);
    Val(EditX2.Text,X2,Code);
    Val(EditY1.Text,Y1,Code);
    Val(EditY2.Text,Y2,Code);
    Val(EditAlfa.TExt,Alfa,Code);
    Val(EditBeta.Text,Beta,Code);
  end;
 end;

procedure TControl_Panel.Movies(Sender: TObject);
Const Pocet = 100;
      Step  = 2*pi/Pocet;
var Code,i         :Integer;
    M              :TMatrix;
    v              :TVector;
    O,A,B,C        :T3DPoint;


  Procedure CoorSystem;
  begin
    With Draw3D do
    begin
     A[1]:=x2;A[2]:=0;A[3]:=0;
     B[1]:=0;B[2]:=y2;B[3]:=0;
     C[1]:=0;C[2]:=0;C[3]:=x2;
     D[1]:=0;D[2]:=0;D[3]:=0;
     cvLine(D,A,255,0,0);
     cvLine(D,B,255,0,0);
     cvLine(D,C,255,0,0);
    end;
  end;

   Procedure Delay;
    begin
      Continue:=False;
      Repeat
        Application.ProcessMessages;
      until Continue;
    end;

  begin
    Setting;
    With Draw3D do
    begin
      Image.Canvas.Pen.Mode:=pmCopy;
      ClearImage(255,255,255);
      Draw3D.Visible:=True;
      Scale(x1,x2,y1,y2);
      SetOrthoAxonProjection(Alfa,Beta);
      SettingBox(Box1);
      CoorSystem;
      cvBox(Box1,0,0,200);
   {  O[1]:=0;O[2]:=0;O[3]:=0;O[4]:=1;
     A[1]:=20;A[2]:=0;A[3]:=0;A[4]:=1;
     B[1]:=0;B[2]:=20;B[3]:=0;B[4]:=1;
     C[1]:=0;C[2]:=0;C[3]:=20;C[4]:=1;}
     Alfa:=2*pi/Pocet;
     SettingBox(Box1);
     cvLine(PointP,PointQ,0,180,0);
    Image.Canvas.Pen.Mode:=pmNotXor;
     cvBox(Box1,0,0,200);
     GenRot(PointP,PointQ,Alfa,M);
    for i:=1 to Pocet do
     begin
      TransOfBox(Box1,M,Box2);
      Application.ProcessMessages;
      Delay;
      if i mod 8 <> 0 then cvBox(Box1,0,0,200);
      cvBox(Box2,0,0,200);
      Box1:=Box2;
    end;
   cvBox(Box1,0,0,200);
  end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;

procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Real;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;


procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
   Application.CreateForm(TDraw3D, Draw3D);
   With Draw3D do
   begin
     Caption:='Rotation arround General Axis';
     Image.align:=alNone;
     ClientWidth:=500;ClientHeight:=500;
     InitImage(500,500);
     Top:=120;Left:=400;
     Visible:=True;
   end;
end;


procedure TControl_Panel.Timer1Timer(Sender: TObject);
begin
 timer1.interval:=trackbar1.Position*20;
 Continue:=True;
end;


end.
